<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<link REL="SHORTCUT ICON" href="favicon.ico">
<title>FAQ</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="description" content="Sudoku generator FAQ" />
<meta name="keywords" content="Sudoku generator FAQ" />
</head>
<body>
<h1>FAQ</h1>
<ul>
<li><a href="#1">Hvordan virker programmet?</a>
<li><a href="#2">Hvordan er svrhedsgraden defineret?</a>
<li><a href="#3">Symmetri, hvad er dette?</a>
<li><a href="#4">Hvordan indtaster man en opgave?</a>
<li><a href="#5">Hvor hurtig er programmet til at lave opgaver?</a>
<li><a href="#6">Hvordan er opgaverne p hjemmesiden lavet?</a>
<li><a href="#7">Hvad er GPL?</a>
<li><a href="#8">Hvordan fr man hjlp til en opgave p hjemmesiden?</a>
<li><a href="#9">Hvorfor fr jeg kun 14 opgaver nr jeg har bedt om 20?</a>
<li><a href="#10">Kommer der nye opgaver i databasen?</a>
<li><a href="#11">Hvorfor er hjemmesiden s langsom?</a>
<li><a href="#12">Hvordan overstter jeg selv programmet p en Windows maskine?</a>
</ul>
<a name="1">
<h2>Hvordan virker programmet?</h2>
<p>Programmet bestr frst og fremmest af en hurtig opgavelser.
Opgavelseren laver en tabel over mulige kandidater i hver celle,
og starter med de celler, der kun har n kandidat. Nr den nr
til celler med flere kandidater, prves disse af en ad gangen.
Dette er kodet vha. en simpel rekursiv algoritme.</p>
<p>Nr programmet skal generere en sudoku opgave, startes der
med lutter tomme felter. Denne "opgave" lses s. Algoritmen
kres nu p en speciel mde, idet den permuterer listen med
kandidater for hver celle. P denne mde fr man opgaver med
forskellige lsninger.</p>
<p>Programmet prver nu at fjerne tal t for t, og checker
hele tiden, at den fremstillede opgave har netop n lsning.
Hvis fjernelsen af et tal giver en opgave med flere lsninger,
sttes tallet tilbage igen. Tallene fjernes i tilfldig rkkeflge,
under hensyntagen til den nskede symmetri i opgaverne.</p>
<p>Nr der ikke kan fjernes flere tal, kres en mere
grundig opgavelser, som bruger nogle flere algoritmer. Denne
algoritme er langsommere, men giver mulighed for at klassificere
opgaverne svrhedsgrad.</p>
<a name="2">
<h2>Hvordan er svrhedsgraden defineret?</h2>
<p>Normalt lses en sudoku opgave p flgende mde:</p>
<p>For hver tomme celle laves en liste med mulige kandidater.</p>
<p>Hvis en celle kun har n kandidat, vlges denne, og listen
med mulige kandidater for de vrige celler ajourfres.</p>
<p>Hvis der hele tiden fremkommer en celle med n kandidat,
klassificeres opgaven som <b>Very easy</b>.</p>
<p>Hvis der ikke er en celle med n kandidat, kigger programmet
efter rkker, sjler eller kasser, hvor et tal kun kan vre t
sted. Opgaver, der kan lses med denne og den frste algoritme
klassificeres som <b>Easy</b>.</p>
<p>Programmet leder efter rkker eller sjler, hvor kandidaterne
til t tal findes indenfor n kasse. Man kan s eliminere de andre
kandidater til samme tal indenfor kassen, som ikke ligger p
samme rkke eller sjle. Opgaver af denne type klassificeres
som <b>Medium</b>.
<p>Programmet leder efter delmngder af n tal, som ligger i n
celler. Man kan s eliminere de vrige kandidater til disse n tal
fra rkken, sjlen eller kassen. For eksempel, hvis to celler
p en rkke kun har kandidaterne 4 og 7, m den ene celle vre 4,
og den anden 7 (eller omvendt), og 4 og 7 kan s fjernes som
kandidater fra de vrige celler i rkken. Opgaver af denne
type klassificeres som <b>Hard</b>.</p>
<p>Opgaver, som ikke kan lses ved disse algoritmer, klassificeres
som <b>Difficult</b>. De kan s lses ved at gtte p en kandidat
til en celle, og se om opgavens s kan lses frdig.</p>
<p>Der findes flere algoritmer end de hr beskrevne, men dem
har jeg ikke kodet ind i programmet (endnu). Algoritmen til
<b>Hard</b>-klassificationen er ivrigt lidt problematisk, da
den krver en stor hjlpetabel. Dette er rsagen til, at jeg
ikke har lavet 5x6 opgaver af den kategori.</p>
<a name="3">
<h2>Symmetri, hvad er dette?</h2>
<p>Sudoku opgaver ser pnest ud, hvis de er symmetriske.</p>
<p>Programmet arbejder pt. med tre klasser: Ingen symmetri,
spejling i x og y aksen og 180 rotation.</p>
<p>Opgaver lavet uden symmetri laves uden at tage hensyn til
symmetri, s de fremstillede opgaver kan rent faktisk godt
vre symmetriske!</p>
<p>Symmetriske opgaver er hurtigere at fremstille, da
man fjerner flere tal ad gangen.</p>
<p>Symmetriske opgaver kan indeholde overfldige tal, alts
tal, som kan fjernes og man har stadigvk en opgave med
n lsning.</p>
<a name="4">
<h2>Hvordan indtaster man en opgave?</h2>
<p>Det kan man ikke umiddelbart - men der er et trick:</p>
<p>Start en teksteditor (fx notepad i windows) og tast opgaven
ind. Tomme celler skrives med et nul. En opgave kan se sledes
ud:</p>
<pre>
000650
003000
500000
000002
000300
012000
</pre>
<p>Kopir tallene med musen, og vlg <b>Paste</b> i sudokuprogrammet. Forinden skal programmet
vre sat til den rette opgavestrrelse, hr 2x3.</p>
<a name="5">
<h2>Hvor hurtig er programmet til at lave opgaver?</h2>
<p>Programmet fremstiller ca. 540 3x3 sudoku opgaver (x/y spejlingssymmetriske) pr. sekund
p en 3.6 GHz Xeon maskine.</p>
<p>Strre opgaver kan tage meget lngere tid, flere minutter
pr. opgave. Jeg har lagt en begrnsning p, hvor mange gange
den rekursive funktion bliver kaldt (maks. 100000 gange) for
ikke at det skal tage alt for lang tid.</p>
<a name="6">
<h2>Hvordan er opgaverne p hjemmesiden lavet?</h2>
<p>Hvis du henter kildeteksten til programmet (.zip eller .tar.gz filerne),
og overstter programmet, laves der ud over det interaktive program (sudoku.exe
i Windows eller sudoku under Linux) ogs en batchversion af programmet.</p>
<p>Batchversionen fremstiller opgaver af en bestemt strrelse og symmetri,
og udskriver opgaverne med tilhrende lsning og svrhedskategori p
konsollen i et format, som passer til at blive indlst i en
<a href="http://www.mysql.com">MySQL database</a>. P hjemmesiden er
der s nogle scripts, kodet i <a href="http://dk.php.net">PHP</a>, som
henter opgaverne fra denne database og prsenterer dem som HTML eller
PDF filer. Kildeteksten til disse scripts er inkluderet i .tar.gz og .zip
filerne.</p>
<a name="7">
<h2>Hvad er GPL?</h2>
<p>Licensen for programmet og scriptene p hjemmesiden er GPL,
beskrevet <a href="http://www.gnu.org/copyleft/gpl.html">hr</a>.</p>
<p>Kort fortalt betyder denne licens, at man m gre alt med kildeteksten
til programmet, bare man gr den nye kildetekst tilgngelig, fx p en
hjemmeside. Du skal beskrive i kildeteksten, hvad du har lavet af
ndringer, og du m ikke lave om i licensen.</p>
<p>Opgaver fremstillet vha. programmet m distribueres
med en henvisning til hjemmesiden.</p>
<a name="8">
<h2>Hvordan fr man hjlp til en opgave p hjemmesiden?</h2>
<p>Hvis du er krt fast i en opgave, kan du bruge flgende trick:</p>
<p>Klik p <b>Vis lsning</b>, og p den side klikker du p <b>Vis forklaring</b>.
Lsningen vises nu sammen med en forklaring p, hvordan man nr frem
til lsningen.</p>
<p>Er du krt fast i en opgave, som du har skrevet ud, kan du finde opgaven
p hjemmesiden ved at taste opgavenummeret ind p <a href="sudoku.php">denne side</a>.
<a name="9">
<h2>Hvorfor fr jeg kun 14 opgaver nr jeg har bedt om 20?</h2>
<p>Hvis du beder om 20 opgaver p <a href="pdf.php">PDF-siden</a>, og
kun fr vist 14, er det fordi databasen kun indeholder 14 opgaver
af den pgldende type. Prv at udvide sgningen med flere forskellige
symmetrier.</p>
<a name="10">
<h2>Kommer der nye opgaver i databasen?</h2>
<p>Ja, hver nat bliver der lavet nye 2x3 og 3x3 opgaver.</p>
<p>Strre opgaver bliver fremstillet "en gang imellem".</p>
<p>Hver gang en opgave er vist, registreres tidspunktet for dette. Opgaver, der
ikke har vret vist fr, vises frst.</p>
<p>Bemrk dog, at hvis du beder om opgaver, der er f af, bliver
tidligere viste opgaver vist igen.</p>
<a name="11">
<h2>Hvorfor er hjemmesiden s langsom?</h2>
<p>Serveren krer p en 512Kbit ADSL forbindelse.</p>
<p>Databasen har flere millioner opgaver, s det tager lidt tid at hente
oplysningerne, specielt hvis der er flere der henter samtidigt.</p>
<p>Der er flere end 10000, som har hentet sudoku.exe programmet, s der er stor interesse for sudoku!</p>
<a name="12">
<h2>Hvordan overstter jeg selv programmet p en Windows maskine?</h2>
<p>Du finder en gratis C kompiler p <a href="http://www.mingw.org/download.shtml">http://www.mingw.org/download.shtml</a>
hent filen: MinGW-3.1.0-1.exe og kr den. Det er ikke den sidste version,
men det er den nemmeste at installere.</p>

<p>I folderen c:\mingw\bin skal du rename filen mingw32-make.exe til
make.exe</p>

<p>Tilfj c:\mingw\bin til PATH. P en engelsk windows 2000 maskine gres
dette ved at hjreklikke p "My Computer", "Properties", "Advanced",
"Environment variables", "System variables", vlg PATH, edit
og tilfj ";c:\mingw\bin". Mske skal windows rebootes for at
path'en virker.</p>

<p>Udpak den sidste zip fil med kildeteksten. Start et command prompt
vindue, cd til folderen du har udpakket kildeteksten i, og skriv
kommandoen:</p>

<p>make windows</p>

<p>Dette genererer filerne sudoku.exe og batchversionen af programmet, bsudoku.exe.</p>

<p><hr></p>
<p></p>
<p>Mogens Kjr, <a href="mailto:mk@lemo.dk">mk@lemo.dk</a></p>
</body>
</html>
