#!/bin/bash

# Run every morning at 2 AM

# Removes simple sudokus (level<2) that havn't been shown (lastused=0)
# and add some more


/bin/date
echo Before creating new

/usr/local/bin/bsudoku 10000 2 3 0 | /usr/bin/mysql -usudoku -psudoku sudoku
/usr/local/bin/bsudoku 10000 2 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku
/usr/local/bin/bsudoku 10000 2 3 2 | /usr/bin/mysql -usudoku -psudoku sudoku
# This finds 3x3 sudoku puzzles that have 28 or fewer numbers and are
# not Very Easy or Difficult
/usr/local/bin/bsudoku 20000 3 3 0 28 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku
/usr/local/bin/bsudoku 100000 3 3 1 28 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku
/usr/local/bin/bsudoku 100000 3 3 2 28 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku

echo After creating new
/bin/date
# I've only found duplicates for sudokus smaller than 3x3
./removeduplicates.pl
echo After remove duplicates
/bin/date

echo make statistics

# Make statistics
./makestat.com

echo before optimize
/bin/date

# Optimize tables
/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
optimize table sudoku;
optimize table problems;
optimize table solutions;
optimize table explanations;
EOF

echo after optimize
/bin/date

